package navigatore;

import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

import lejos.pc.comm.NXTComm;
import lejos.pc.comm.NXTCommFactory;
import lejos.pc.comm.NXTInfo;

public class Main extends JFrame implements Runnable {

	private JPanel contentPane;
	private JTextField txtSpeed;
	private JTextField txtTravel;
	private JTextField txtRotate;
	private JButton btnConnetti;
	private JTextField txtDati;
	private DataOutputStream dos;
	private final int SPEED = 1;
	private final int TRAVEL = 2;
	private final int ROTATE = 3;
	private boolean disconnected;
	

	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main frame = new Main();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	public Main() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		btnConnetti = new JButton("Connetti");
		btnConnetti.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				attivaComunicazione();
			}
		});
		btnConnetti.setBounds(10, 11, 89, 23);
		contentPane.add(btnConnetti);
		
		JLabel lblStato = new JLabel("Stato");
		lblStato.setBounds(51, 45, 46, 14);
		contentPane.add(lblStato);
		
		txtDati = new JTextField();
		txtDati.setBounds(90, 42, 86, 20);
		contentPane.add(txtDati);
		txtDati.setColumns(10);
		
		JLabel lblComandi = new JLabel("Comandi");
		lblComandi.setBounds(10, 89, 46, 14);
		contentPane.add(lblComandi);
		
		JButton btnSetspeeds = new JButton("setSpeed(s)");
		btnSetspeeds.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				setSpeed();
			}
		});
		btnSetspeeds.setBounds(10, 114, 110, 23);
		contentPane.add(btnSetspeeds);
		
		JButton btnTraveld = new JButton("travel(d)");
		btnTraveld.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				travel();
			}
		});
		btnTraveld.setBounds(10, 148, 110, 23);
		contentPane.add(btnTraveld);
		
		JButton btnRotatea = new JButton("rotate(a)");
		btnRotatea.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				rotate();
			}
		});
		btnRotatea.setBounds(10, 182, 110, 23);
		contentPane.add(btnRotatea);
		
		JLabel lblS = new JLabel("s");
		lblS.setBounds(144, 118, 46, 14);
		contentPane.add(lblS);
		
		JLabel lblD = new JLabel("d");
		lblD.setBounds(144, 152, 46, 14);
		contentPane.add(lblD);
		
		JLabel lblA = new JLabel("a");
		lblA.setBounds(144, 186, 46, 14);
		contentPane.add(lblA);
		
		txtSpeed = new JTextField();
		txtSpeed.setBounds(162, 115, 104, 20);
		contentPane.add(txtSpeed);
		txtSpeed.setColumns(10);
		
		txtTravel = new JTextField();
		txtTravel.setBounds(162, 149, 104, 20);
		contentPane.add(txtTravel);
		txtTravel.setColumns(10);
		
		txtRotate = new JTextField();
		txtRotate.setBounds(162, 183, 104, 20);
		contentPane.add(txtRotate);
		txtRotate.setColumns(10);
	}
	
	public void attivaComunicazione() {
		Thread thread = new Thread(this);
		thread.setDaemon(true);
		thread.start();
		
		try {
			NXTComm nxtComm = NXTCommFactory.createNXTComm(NXTCommFactory.BLUETOOTH);
			NXTInfo[] nxtInfo = nxtComm.search("NXT");
			if (nxtInfo.length > 0)
				if (nxtComm.open(nxtInfo[0])) {
					btnConnetti.setEnabled(false);
					btnConnetti.setText("Connesso");
					dos = new DataOutputStream(nxtComm.getOutputStream());
					txtDati.setText("NXT connesso");
				}
				else {
					System.out.println("nessun dispositivo trovato");
				}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(this, "Impossibile stabilire la connesisone");
		}
		disconnected = false;
	}
	
	@Override
	public void run() {
		disconnected = true;
		txtDati.setText("in attesa");
		while (disconnected) {
				txtDati.setText(txtDati.getText()+".");
				try {
					Thread.sleep(1000);
				} catch (Exception e) {
					e.printStackTrace();
				}
		}
	}
	
	public void setSpeed() {
		int speed = Integer.parseInt(txtSpeed.getText());
		try {
			dos.writeInt(SPEED);
			dos.writeInt(speed);
			dos.flush();
		} catch (IOException e) {
		}
	}
	
	public void travel() {
		int travel = Integer.parseInt(txtTravel.getText());
		try {
			dos.writeInt(TRAVEL);
			dos.writeInt(travel);
			dos.flush();
		} catch (IOException e) {
		}
	}
	
	public void rotate() {
		int rotate = Integer.parseInt(txtRotate.getText());
		try {
			dos.writeInt(ROTATE);
			dos.writeInt(rotate);
			dos.flush();
		} catch (IOException e) {
		}
	}
	
}
